#include "MyBoxManager.h"

namespace tutorial {

	MyBoxManager::MyBoxManager(std::string id) : cg::Entity(id) {
	}
	MyBoxManager::~MyBoxManager() {
		for(tBoxIterator i = _boxes.begin(); i != _boxes.end(); i++) {
			delete (*i);
		}
	}
	void MyBoxManager::init() {
		int nbox = cg::Properties::instance()->getInt("NBOX");
        std::ostringstream os;
        os << nbox << " boxes on screen.";
		nboxMessage = os.str();
		for(int i = 0; i < nbox; i++) {
			std::ostringstream os;
			os << "Box" << i;
			MyBox *box = new MyBox(os.str());
			box->init();
			_boxes.push_back(box);
		}
	}
	void MyBoxManager::update(unsigned long elapsed_millis) {
		for(tBoxIterator i = _boxes.begin(); i != _boxes.end(); i++) {
			(*i)->update(elapsed_millis);
		}
	}
	void MyBoxManager::draw() {
		for(tBoxIterator i = _boxes.begin(); i != _boxes.end(); i++) {
			(*i)->draw();
		}
	}
	void MyBoxManager::drawOverlay() {
		glColor3d(0.9,0.1,0.1);
		cg::Util::instance()->drawBitmapString(nboxMessage,10,10);
	}
}